import traer.physics.*; //used in the thermic vibration

//constants used in thermic vibration
ParticleSystem physics;
Particle[][] particles;
  Particle[][] lattice;

float[][] ferroAngle;

int gridSize = 6;
float SPRING_STRENGTH = 0.005;
float SPRING_DAMPING = 0.01;
float gridStepX = 22;
float gridStepY = 22;

int step = 0; //animation step 
boolean toggleText = false; //first run give us the currrent step in the first hysteretic cycle 
boolean toggleDomain = false; //shows the magnetic domain structure for the ferromagnetics 

PGraphics pg; //Buffers for every step  
PGraphics Wall; //P3D buffer used for drawing the domain wall
PGraphics graphSmall; //draws graphs
//PGraphics graph;
PFont f;
PFont  fontTitle;

Button back,MagMat1, MagMat2, MagMat3;//Buttons
boolean toggleGraph = true; 
String[] formula1 = {
  "B*", "=","μ_0","H*","+", "μ_0", "M*"
};

//String[] items = {"1.:Introdução","2.:Materiais magnéticos","3.:Domínios Magneticos","4.:Curva de Magnetização","5.:Curva de Histerese"};
float xcursor, ycursor;
float t;
String[] explica1 = {
  "Indução\nMagnética","", "Permeabilidade\nMagnética do vácuo","Campo Magnético\nExterno","", "Permeabilidade\nMagnética do vácuo", "Magnetização"
};

int showWall=0;
int MagMat = 2;


//TEMPERATURE
float T=300;
Scrollbar Temp;
Scrollbar Vert;
float angle = 0;
float mod = 0;

PImage mask;
PFont fontButton;
textBox showText;

Credito credito;  //credit

int lang = 0; //language

void setup() {
  size(600,650, JAVA2D);  
  hint(ENABLE_NATIVE_FONTS);  
  frameRate(16);
  
  //BUTTONS AND LISTENERS
  //PGraphics _layer, float _dxoffset, float _dyoffset, int _x, int _y, 
  // int _TWidth, int _THeight, String _defaulttext, int _Border, float _Margin, color _TColour)
  setText();
  
  back = new Button(515,525,70,30, polyScreen[0][lang], true);
  MagMat1 = new Button(210,204-80,320,132,"",false);
  MagMat2 = new Button(210,350-78,320,132,"",false );
  MagMat3 = new Button(210,496-75,320,132,"", false );


  //SCROLLBAR
  //Scrollbar (int xp, int yp, int sw, int sh, int l) {
  Temp = new Scrollbar(480, 360, 140,10, 3, 10,10); 

  //Vert = new Scrollbar(440, 120, 10, 80, 3);
  Temp.newspos = 415;
  fontButton = loadFont("ArialNarrow-Bold-24.vlw");
  fontTitle = loadFont("ArialUnicodeMS-72.vlw");
  f = loadFont("ArialUnicodeMS-24.vlw");
  showText = new textBox(225,420, 310, 200, "", f, 14,10, 140); 
  
  //(float _x, float _y, float _width,float _height, String _texto, PFont _font, int _fontsize, float _sWidth, float _sHeight) 
  //creating the traer.physical used to represent thermic vibration 
  physics = new ParticleSystem(0.1, 0.01);
  particles = new Particle[gridSize][gridSize];
  lattice = new Particle[gridSize][gridSize];
  ferroAngle = new float[gridSize][gridSize];

  for (int i = 0; i < gridSize; i++)
  {
    for (int j = 0; j < gridSize; j++)
    {
      particles[i][j] = physics.makeParticle(0.2, j * gridStepX+20, i * gridStepY+20, 0.0);
      lattice[i][j] = physics.makeParticle(0.2, j * gridStepX+20, i * gridStepY+20, 0.0);
      ferroAngle[i][j] = cos(i*j)*random(-3,3);
      if (j > 0)
      {
        physics.makeSpring(particles[i][j - 1], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, gridStepX);
      }
      physics.makeSpring(lattice[i][j], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, 0);
      lattice[i][j].makeFixed();
    }
  }
  for (int j = 0; j < gridSize; j++)
  {
    for (int i = 1; i < gridSize; i++)
    {
      physics.makeSpring(particles[i - 1][j], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, gridStepY);
    }
  }
  physics.setGravity(0);
  randomSeed(3);

  mask = loadImage("mask.png");
  pg= createGraphics(150,150, JAVA2D);
  Wall = createGraphics(200,200,P3D);
  graphSmall = createGraphics(100,100, JAVA2D);

  //dominios = loadImage("dominio.png");
  smooth();

  credito= new Credito();


}

void draw() {
  //rectMode(CENTER);
     background(255);
    fill(0);
    ////////////////SPLASH SCREEN////////////////////
  textFont(fontTitle);
  textAlign(CENTER);

  //textLeading(16);
  textSize(32);
    fill(31,142,0);
  text(polyScreen[1][lang], width/2, 40);
  fill(0);
  textSize(13); 
  textLeading(13);
  text(polyExplain[7][lang]
    ,  width/2,510);


  textAlign(LEFT);       
  textFont(fontButton,16);
  text(polyScreen[2][lang],50,150-80);     
  text(polyScreen[3][lang],50,295-78);
  text(polyScreen[4][lang], 50,440-75);
  textFont(f, 12);
  textLeading(12);
  
  text(polyExplain[0][lang],140,150, 180,150);    
  text(polyExplain[1][lang],140,295, 180,150);  
  text(polyExplain[2][lang],140,440, 180,150);  

  /*if(T> Tc) 
   text("Para temperaturas acima da "+
   "temperatura de Curie, a vibração térmica "+ 
   "suplanta a tendência dos momentos magnéticos dos "+
   "átomos a se alinharem, e o material passa a se comportar " +
   "como um paramagnético"   ,Temp.xpos-20, Temp.ypos+80, 120,150);  */

  //text("Nesta animação, exploraremos diferentes tópicos\nenvolvendo as propriedades magnéticas dos materiais", width/2, 90);    
  textFont(fontButton,14);
  textLeading(14);
  textAlign(LEFT); 
  
//writeText();

  T= 1200*(Temp.getPos()+0.1);
  
  if(step == 0) {////////////////////////0
    imageMode(CORNER); 

    //animating and drawing the atoms 
    //println(int(millis())/10);
    
    physics.tick();
    randomSeed(millis());
    for (int j = 0; j < gridSize; j++) {
      for (int i = 1; i < gridSize; i++) {
        particles[i][j].velocity().add(random(-0.0002*(T+200)/15,0.0002*(T+200)/15), random(-0.0002*(T+200)/15,0.0002*(T+200)/15), 0);
      }
    }

    randomSeed(3);

    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0, angle,T,0,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }

    //drawing the atoms
    image(pg, width/3+30, 130-80, 150, 150);

    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0, angle,T,1,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }

    //drawing the atoms
    image(pg, width/3+30, 275-78, 150, 150);

    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0, angle,T, 2,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }

    //drawing the atoms
    image(pg, width/3+30, 420-75, 150, 150);
  }
  //controlling the temperature with a slider
  //    image(explanation, 300,34);

  ///////////////MAGNETIC MATERIALS//////////
  if(step==1) {         //////////////////////1
    rectMode(CORNERS);
    noStroke();
    fill(150,150);
    rect(0,0,width, height);
    fill(255);
   rect(40, 55, 560, 550);

   rect(400, 55, 560, 550); 

    //animating and drawing the atoms 
    //println(int(millis())/10);
    physics.tick();
    randomSeed(millis());
    for (int j = 0; j < gridSize; j++) {
      for (int i = 1; i < gridSize; i++) {
        particles[i][j].velocity().add(random(-0.0002*T/300,0.0002*T/300), random(-0.0002*T,0.0002*T), 0);
      }
    }
    randomSeed(3);
    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0, angle,T,MagMat,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }
    //drawing the atoms
  
      imageMode(CENTER);
      image(pg, width/2-70, 205, 220,220);


    showText.display();
    textAlign(CENTER);
    textLeading(14);
    textSize(18);  
    fill(0); 

    if(MagMat==0) {
      textFont(fontTitle);
      textAlign(CENTER);
      imageMode(CORNER);
      textLeading(16);
      textSize(32);
      fill(31,42,0);
      text(  polyScreen[2][lang] , width/2-70, 90);  
      fill(0);

      showText.countLines=105;
      showText.texto = 
      polyExplain[4][lang];
    }
    
    if(MagMat==1) {
      textFont(fontTitle);
      textSize(32);
      text(  polyScreen[3][lang], width/2-70, 90);  
      textAlign(CENTER);
      showText.countLines=350;
      showText.texto= polyExplain[5][lang];
    }

    if(MagMat==2) {
      textFont(fontTitle);
      textSize(32);
      textAlign(CENTER);
      text(  polyScreen[4][lang], width/2-70, 90);  
      textSize(12);
      showText.countLines=1010;
      showText.texto= polyExplain[6][lang];
    }
  }
  //controling and showingthe external field H
  textFont(fontButton,14);
  textAlign(CENTER);
  textLeading(14);
  fill(0);
  text(polyScreen[5][0], 480, 140);
  vector(480,240,140);      
  if((step==0)||(MagMat==2)) {
    textAlign(CENTER);
    variable("T_c", polyExplain[3][lang], 511,387, 16, 430,393,0, 0);
    arrowline( 514, 375,  514, 362, g);
  }
  
  
  manageButtons();
  fill(0);
  textFont(fontButton,14);
  textLeading(14);
  textAlign(LEFT);
  text(polyScreen[6][lang], Temp.xpos-50, Temp.ypos-10);
  if(T<400) text(polyScreen[7][lang], Temp.xpos+25, Temp.ypos-10);
  if((T>=400)&&(T<900)) text(polyScreen[8][lang], Temp.xpos+25, Temp.ypos-10);
  if(T>=900) text(polyScreen[9][lang], Temp.xpos+25, Temp.ypos-10);
  Temp.update();
  Temp.display();
  pushStyle();
  credito.display();
  popStyle();
}

//controls the buttons
void manageButtons() {
  if(step==1) back.display();
  back.update();

  if(step == 0) {
     showText.yScroll.newspos = 390;
    rectMode(CENTER);
    stroke(0,12);
    //MagMat1.display();
    MagMat1.update();
    if(MagMat1.over) {
      fill(200,10);
      rect(210,204-80,320,132);
    }

    //MagMat2.display();
    MagMat2.update();
    if(MagMat2.over) {
      fill(200,10);
      rect(210,350-78,320,132);
    }        

    //MagMat3.display();
    MagMat3.update();
    if(MagMat3.over) {
      fill(200,10);
      rect(210,496-75,320,132);
    }
  }
}
int checkcurve= 1;


void mousePressed() {
  if(step==0) credito.mousePressed();
  println(mouseX +"+"+ mouseY);
  //if((nextMagMat.press())&&(MagMat<2)) MagMat++;
  //if((backMagMat.press())&&(MagMat>0)) MagMat--;
  if(!credito.showCred) {
    if(step == 0) {
      if(MagMat1.press()) {
        step = 1;
        MagMat = 0;
      }
      if(MagMat2.press()) {
        step =1;
        MagMat = 1;
      }
      if(MagMat3.press()) {
        step = 1;
        MagMat = 2;
      }
    }

    if(step!=0) {
      if(back.press()) {
        step=0;
        //  L.setOpen (false);
      }
    }
  }
}


void mouseReleased() {
  credito.mouseReleased();
  back.release();
  MagMat1.release();
  MagMat2.release();
  MagMat3.release();
}


