class Scrollbar {
  float swidth, sheight;    // width and height of bar
  float xpos, ypos;         // x and y position of bar
  float spos, newspos;    // x position of slider
  // float sposMin, sposMax;   // max and min values of slider
  float loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  float c = 0.65, b = 2.5;
  float sliderWidth, sliderHeight;


  Scrollbar (float xp, float yp, float sw, float sh, float l, float sWidth, float sHeight) {
    swidth = sw;
    sheight = sh;
    float widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos;
    newspos = spos;
    sliderWidth = sWidth;
    sliderHeight = sHeight; 
   if(swidth > sheight){   
       spos = xpos-swidth/2+50;
    }else spos = ypos-sheight/2;
    // sposMin = xpos-swidth/2.1;
    // sposMax = xpos + swidth/1.9;
    loose = l;
  }

  Scrollbar (float xp, float yp, float sw, float sh, float l) {      
    swidth = sw;
    sheight = sh;
    float widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    newspos = spos;

    // sposMin = xpos-swidth/2.1;
    // sposMax = xpos + swidth/1.9;
    loose = l;
  }

  void update() {
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }

    if(mousePressed && over) {
      locked = true;
    }

    if(!mousePressed) {
      locked = false;
    }

    if(locked) {
      if(swidth>=sheight) {
        newspos=mouseX;      
        if (newspos-sliderWidth/2<xpos-swidth/2) newspos = xpos-swidth/2+sliderWidth/2;
        if (newspos+sliderWidth/2>xpos+swidth/2) newspos = xpos+swidth/2-sliderWidth/2;
      } 
      else {
        newspos = mouseY;
        if (newspos-sliderHeight/2<ypos-sheight/2) newspos = ypos-sheight/2+sliderHeight/2;
        if (newspos+sliderHeight/2>ypos+sheight/2) newspos = ypos+sheight/2-sliderHeight/2;
      }
    }

    spos = (newspos);
  }

  int constrain(int val, int minv, int maxv) {
    return min(max(val, minv), maxv);
  }

  boolean over() {
    if(mouseX > xpos-swidth/2 && mouseX < xpos+swidth/2 &&
      mouseY > ypos-sheight/2 && mouseY < ypos+sheight/2) {
      return true;
    } 
    else {
      return false;
    }
  }

  void display() {
    pushStyle();
    beginShape(QUADS);
    noStroke();

    fill(#AAAAAA);
    vertex(xpos - (swidth + b)/2, ypos - (sheight + b)/2);
    vertex(xpos - (swidth)/2, ypos - (sheight)/2);
    vertex(xpos - (swidth)/2, ypos + (sheight)/2);
    vertex(xpos - (swidth + b)/2, ypos + (sheight + b)/2);

    vertex(xpos - (swidth + b)/2, ypos + (sheight + b)/2);
    vertex(xpos - (swidth)/2, ypos + (sheight)/2);
    vertex(xpos + (swidth)/2, ypos + (sheight)/2);
    vertex(xpos + (swidth + b)/2, ypos + (sheight + b)/2);   


    fill(#000001);
    vertex(xpos - (swidth + b)/2, ypos - (sheight + b)/2);
    vertex(xpos - (swidth)/2, ypos - (sheight)/2);
    vertex(xpos + (swidth)/2, ypos - (sheight)/2);
    vertex(xpos + (swidth + b)/2, ypos - (sheight + b)/2);

    vertex(xpos + (swidth + b)/2, ypos - (sheight + b)/2);
    vertex(xpos + (swidth)/2, ypos - (sheight)/2);
    vertex(xpos + (swidth)/2, ypos + (sheight)/2);
    vertex(xpos + (swidth + b)/2, ypos + (sheight + b)/2);
    endShape();


    fill(150,5);     

    rectMode(CENTER);
    rect(xpos, ypos, swidth, sheight);

    if(over || locked) {
      fill(87, 87, 87);
    }
    else {
      fill(122, 122, 122);
    }

    if(swidth>sheight) {
      rect(spos, ypos, sliderWidth, sliderHeight);
      beginShape(QUADS);
      noStroke();
      fill(#000001);
      vertex(spos - (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);
      vertex(spos - (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos - (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos - (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);

      vertex(spos - (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);
      vertex(spos - (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos + (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos + (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);   

      fill(#AAAAAA);
      vertex(spos - (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);
      vertex(spos - (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos + (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos + (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);

      vertex(spos + (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);
      vertex(spos + (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos + (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos + (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);
      endShape();
    }
    else {
      rect(xpos, spos, sliderWidth, sliderHeight);
      beginShape(QUADS);
      noStroke();
      fill(#000001);
      vertex(xpos - (sliderWidth + b)/2, spos - (sliderHeight + b)/2);
      vertex(xpos - (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos - (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos - (sliderWidth + b)/2, spos + (sliderHeight + b)/2);

      vertex(xpos - (sliderWidth + b)/2, spos + (sliderHeight + b)/2);
      vertex(xpos - (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos + (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos + (sliderWidth + b)/2, spos + (sliderHeight + b)/2);   

      fill(#AAAAAA);
      vertex(xpos - (sliderWidth + b)/2, spos - (sliderHeight + b)/2);
      vertex(xpos - (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos + (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos + (sliderWidth + b)/2, spos - (sliderHeight + b)/2);

      vertex(xpos + (sliderWidth + b)/2, spos - (sliderHeight + b)/2);
      vertex(xpos + (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos + (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos + (sliderWidth + b)/2, spos + (sliderHeight + b)/2);
      endShape();
    }
    fill(0);
    popStyle();
  }

  float getPos() {         //now working 
    // Convert spos to be values between                      
    // 0 and the total width of the scrollbar
    if(swidth>sheight) return (spos-xpos+swidth/2-sliderWidth/2)/(swidth-sliderWidth);   
    else    return (spos-ypos+sheight/2-sliderHeight/2)/(sheight-sliderHeight);
  }
}

